import com.amazonaws.ClientConfiguration;
import com.amazonaws.Protocol;
import com.amazonaws.auth.BasicAWSCredentials;
import com.amazonaws.services.s3.AmazonS3;
import com.amazonaws.services.s3.AmazonS3Client;
import com.amazonaws.services.s3.model.*;

import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;


public class S3Test {
    private AmazonS3 client = null;
    private String accessKeyID = "OWN3N2VkYXg";
    private String secretAccessKeyID = "25bc8b806b47e3bd7fed3543f8447b8b";
    private String endpointName = "gic.cnbj01.cdsgss.com";
    private ClientConfiguration config = new ClientConfiguration();

    public S3Test() {
        config.setProtocol(Protocol.HTTP);
        //???s3????????
        config.setSignerOverride("S3SignerType");
        client = new AmazonS3Client(
                new BasicAWSCredentials(accessKeyID, secretAccessKeyID), config);
        client.setEndpoint(endpointName);
    }

    public void listBuckets() {
        List<Bucket> buckets = client.listBuckets();
        for (Bucket bucket : buckets) {

            System.out.println("    " + bucket.getName());
            System.out.println("    " + bucket.getCreationDate());
            System.out.println("    " + bucket.getOwner());
            System.out.println(" ------------------------------------ ");
        }
    }

    public void listObjects(String bucketName) {
        final ListObjectsRequest req = new ListObjectsRequest().withBucketName(bucketName);
        ObjectListing objectListing = client.listObjects(req);
        for (S3ObjectSummary objectSummary
                : objectListing.getObjectSummaries()) {
            System.out.println(" * " + objectSummary.getKey() + " " +
                    "(size = " + objectSummary.getSize() + ")");
        }
    }

    public void getObject(String bucketName, String objectKey, String localFilePath) throws IOException {
        GetObjectRequest req = new GetObjectRequest(bucketName, objectKey);
        S3Object obj = client.getObject(req);
        S3ObjectInputStream s3i = obj.getObjectContent();

        FileOutputStream localFile
                = new FileOutputStream(localFilePath);

        byte readBuffer[] = new byte[2048];
        int bufferSize;
        while (-1 != (bufferSize = s3i.read(readBuffer))) {
            localFile.write(readBuffer, 0, bufferSize);
        }
        localFile.close();
    }

    //1476691847235/blocks/2016-10-17-16-20-18/0/000000.bak
    public static void main(String[] args) {
//		new S3Test().listBuckets();
//		new S3Test().listObjects("z8xi76fq");
        try {
//			new S3Test().getObject("bucket", "/11485938939.mp4", "D:/11485938939.mp4");
            new S3Test().listBuckets();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}


